--Hey Guys It's Me Cman 2 Times Is A Charm Thanks To Cobalt For Making The Example Script Exist If That Didn't Exist Cman Would be Totally Different!
local ScriptLoaded = false

--Now let's encase the rest of our code inside of ThinkFrame...
addHook("ThinkFrame", function()
	--... so that we can check each frame to see if the script has been loaded yet.
	if not(ScriptLoaded)
		and CBW_Battle --CBW_Battle is the master table for all of BattleMod's functions. Attempting to run our scripts without Battle loaded will result in a lua error, so we have to check before trying to run the rest of the code.
		then
		ScriptLoaded = true --Flip this to true so that we don't try to run this code more than once.
		local B = CBW_Battle --Just for convenience, we're going to truncate this table; it'll make writing functions a little less cumbersome.
				
		--Now let's create our action.
		local RingBarrage = function(mo,doaction)

			local player = mo.player
			
			--Now for some definitions:
			player.actiontext = "C Bomb Barrage" 
			player.actionrings = 10 
			player.action2text = nil 
			player.action2rings = 0 
			
			
			if not(B.CanDoAction(player)) --CBW_Battle.CanDoAction will return true/false whether actions are "allowed" based on certain external conditions.
				player.actionstate = 0 --Default action state
				return end	
	
			if player.actionstate == 0 --actionstate can be used to determine the phase of a character's attack.
				if doaction == 1 --Action key was pressed and we can perform an action
					player.actionstate = 1 --This moves us onto the next actionstate
					player.actiontime = 0 --This can be used to keep track of time in a certain state. Unlike its name suggests, this variable does NOT automatically tic up or down, so you will have to add or subtract from this variable manually if you want it to operate like a timer.
					B.PayRings(player) --Spend actionring amount and plays the anti-ring sfx.
					S_StartSound(mo,sfx_s3k3c)
					
				end
			end
			
			if player.actionstate == 1 --This state will serve as our startup lag
				player.actiontime = $+1 --Tic this upwards to keep track of how long we've been in this state.
				
				--Halt our momentum
				P_InstaThrust(mo,mo.angle,0)
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale,0)
				--Make us spin
				player.pflags = ($|PF_SPINNING)&~PF_JUMPED
				mo.state = S_PLAY_ROLL
				P_SpawnThokMobj(player) --Just a little aesthetics
				
				if player.actiontime == 20 then --Set time till next state
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			
			if player.actionstate == 2 --In this state our character is currently performing their action.
				player.actiontime = $+1
				--Creating our projectile stream
				if player.actiontime%3==0 --This condition will return true once every four tics
					P_SPMAngle(mo,MT_JETTBULLET,mo.angle,0)
				end
				
				--Do some recoil
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale*2,0)
				P_InstaThrust(mo,mo.angle+ANGLE_180,mo.scale*6)
				B.ApplyCooldown(player,TICRATE*2) --Waittime before player can use this action again. If the player used this action without any rings on-hand, the waittime is doubled.
				mo.state = S_PLAY_FALL
				player.pflags = $&~(PF_SPINNING)
				player.drawangle = mo.angle
				
				--Reset player state
				if player.actiontime == 20
					player.actionstate = 0
				end
			end
			
		end --End of action function.
		
		local PriorityFunc = function(player)
			if player.actionstate == 1 then
				B.SetPriority(player,1,3,nil,1,3,"midair charge spin")
				
			end
		end
		
		
		--Let's now assign these functions to the character:
		CBW_Battle.SkinVars["cman"] = {
			special = RingBarrage,
			func_priority_ext = PriorityFunc
		}


	end
end)